{% extends 'base.html' %}
{% load static %}

{% block title %}Store{% endblock %}

{% block content %}

<div>
    
    <p style="font-family: 'Brush Script MT', cursive; font-size:35px; display: inline;" class="mt-2">All Books</p>
    
    <div style="display:inline; float:right; margin-top: 10px;">

        <select class="form-select form-select-lg " name="category" id="bookSortSelectId">
            <option value="">Sort By</option> 
                <option>price</option> 
                <option>title</option>
        </select>

    </div>
    <div style="display:inline; float:right; margin-top: 10px; ">

        <select class="form-select form-select-lg " name="category" id="bookCategoryId">
            <option value="">Select Category</option>
            {% for category in category_list %}
                <option value="{{category.id}}">{{category.name}}</option>
            {% endfor %}
        </select>
    </div>
</div>
<hr>
    <div class="row my-3" id="bookListId">
        
        {% for book in book_list %}
        <div class="col-sm-3 mt-3" >
            <div class="card card-hover" id="card1" >
                <img src="{{book.image.url}}" style="height: 270px; width:100%;" class="card-img-top" alt="...">
                <div class="card-body">
                    <a href="{% url 'book_detail' book.id %}" style="text-decoration: none;"><h5 class="card-title">{{book.title|truncatechars:18}}</h5></a>
                    <p class="card-text">{{ book.description|truncatechars:18 }}</p> 
                    <p class="alert alert-secondary"><b>Price:Rs.</b> {{book.price}}</p>
                </div>
            </div>
        </div> 
        {% endfor %}

    </div>

    
<script>

$('#searchFormId').on('submit',function(e){
    e.preventDefault();
    let formData = new FormData(this);
    const searchUrl = "{% url 'book_search' %}"+ "?keyword=" +formData.get('keyword');
    
    $.ajax({
        url: searchUrl,
        method: 'GET',

        success: function(response){
                $('.container').empty().html(response);
                $('#searchFormId')[0].reset();
            },
        error: function(err){
            console.log(err);
        }
    })

})

$('#bookSortSelectId').change(function(){
        const sort_by = $(this).val(); 
        console.log(sort_by)

        const request_url = "{% url 'book_sort' %}"  + "?sort_by="+sort_by;
        console.log(request_url);

        $.ajax({
            url: request_url,
            method: "GET",

            success: function(response){
                let result = ``;
                if(response.status==200){ 
                    let url;
                    let desc;
                    $.each(response.books, function(index, book){
                        url = "{% url 'book_detail' 11 %}".replace(11, book.id);  
                        result += `
                        <div class="col-sm-3 mt-3" >
                            <div class="card card-hover" id="card1" >
                                <img src="${book.image}" style="height: 270px; width:100%;" class="card-img-top" alt="...">
                                <div class="card-body">
                                    <a href="${url}" style="text-decoration: none;"><h5 class="card-title">${book.title.slice(0,18)}</h5></a>
                                    <p class="card-text">${book.description.slice(0,18)}</p>
                                    <p class="alert alert-secondary"><b>Price:Rs.</b> ${book.price}</p>
                                </div>
                            </div>
                        </div> `
                    });

                    $('#bookListId').empty().append(result);
                }else if(response.status == 400){
                    $.each(response.books, function(index, book){
                        url = "{% url 'book_detail' 11 %}".replace(11, book.id);
                        result += `
                        <div class="col-sm-3 mt-3" >
                            <div class="card card-hover" id="card1" >
                                <img src="${book.image}" style="height: 270px; width:100%;" class="card-img-top" alt="...">
                                <div class="card-body">
                                    <a href="${url}" style="text-decoration: none;"> <h5 class="card-title">${book.title.slice(0,18)}</h5></a>
                                    <p class="card-text">${book.description.slice(0,18)}</p>
                                    <p class="alert alert-secondary"><b>Price:Rs.</b> ${book.price}</p>
                                </div>
                            </div>
                        </div> `
                    });

                    $('#bookListId').empty().append(result);
                }
            },
            error: function(err){
                console.log(err)
            }
        })
    })  



    $('#bookCategoryId').change(function(){
        const category_id = $(this).val(); 
        const request_url = "{% url 'category_sort' %}"  + "?category_id="+category_id;
        // console.log(request_url);

        $.ajax({
            url: request_url,
            method: "GET",

            success: function(response){
                let result = ``;
                if(response.status==200){ 
                    let url;
                    $.each(response.books, function(index, book){
                        url = "{% url 'book_detail' 11 %}".replace(11, book.id);
                        result += `
                        <div class="col-sm-3 mt-3" >
                            <div class="card card-hover" id="card1" >
                                <img src="${book.image}" style="height: 270px; width:100%;" class="card-img-top" alt="...">
                                <div class="card-body">
                                    <a href="${url}" style="text-decoration: none;"><h5 class="card-title">${book.title.slice(0,18)}</h5></a>
                                    <p class="card-text">${book.description.slice(0,18)}</p>
                                    <p class="alert alert-secondary"><b>Price:Rs.</b> ${book.price}</p>
                                </div>
                            </div>
                        </div> `
                    });

                    $('#bookListId').empty().append(result);
                }else if(response.status == 400){
                    $.each(response.books, function(index, book){
                        url = "{% url 'book_detail' 11 %}".replace(11, book.id);
                        result += `
                        <div class="col-sm-3 mt-3" >
                            <div class="card card-hover" id="card1" >
                                <img src="${book.image}" style="height: 270px; width:100%;" class="card-img-top" alt="...">
                                <div class="card-body">
                                    <a href="${url}" style="text-decoration: none;"> <h5 class="card-title">${book.title.slice(0,18)}</h5></a>
                                    <p class="card-text">${book.description.slice(0,18)}</p>
                                    <p class="alert alert-secondary"><b>Price:Rs.</b> ${book.price}</p>
                                </div>
                            </div>
                        </div> `
                    });

                    $('#bookListId').empty().append(result);
                }
            },
            error: function(err){
                console.log(err)
            }
        })
    })  

</script>
{% endblock %}